{combine_script id="jquery.ui" path="themes/default/js/ui/minified/jquery.ui.core.min.js" require='jquery'}
{combine_script id="jquery.ui.dialog" path="themes/default/js/ui/minified/jquery.ui.dialog.min.js" require='jquery'}

{literal}

<script type="text/javascript">
/**
 * include this template in a page and use dialogChooseASEKeywordBox.show({options}) to display
 * the dialog box
 *
 */
dialogChooseASEKeywordBox = function()
{
  var dialogOptions = {
      id:'',
      eventOk:null,
      cBuilder:null,

      values: {
        keyword:'',
        optIgnoreCase:'y',
        optWholeWords:'n',
        searchName:'y',
        searchDesc:'y',
        searchFileName:'n'
      },
    };

  /**
   * initialize the dialog box
   */
  var initDialogBox = function()
  {
    $("#iDialogASEKeywordChoose")
    .dialog(
      {
        autoOpen: false,
        resizable: false,
        width:550,
        height:200,
        modal: true,
        draggable:true,
        dialogClass: 'gcBgTabSheet gcBorder',
        title: '{/literal}{"ase_search_keyword"|@translate}{literal}',
        open: function(event, ui)
        {
        },
        buttons:
        {
          '{/literal}{"ase_ok"|@translate}{literal}':
            function()
            {
              if(checkValidity())
              {
                dialogOptions.values.keyword=$('#iASEKeywordKeyword').val();
                dialogOptions.values.optIgnoreCase=$('#iASEKeywordIgnoreCase').attr('checked')?'y':'n';
                dialogOptions.values.optWholeWords=$('#iASEKeywordWholeWords').attr('checked')?'y':'n';
                dialogOptions.values.searchName=$('#iASEKeywordSearchName').attr('checked')?'y':'n';
                dialogOptions.values.searchDesc=$('#iASEKeywordSearchDesc').attr('checked')?'y':'n';
                dialogOptions.values.searchFileName=$('#iASEKeywordSearchFileName').attr('checked')?'y':'n';

                if(dialogOptions.cBuilder!=null)
                {
                  setCBuilderItem(dialogOptions.id, dialogOptions.values);
                }

                if(dialogOptions.eventOk!=null)
                {
                  dialogOptions.eventOk(dialogOptions.id, dialogOptions.values);
                }
                $(this).dialog('close');
              }
            },
          '{/literal}{"ase_cancel"|@translate}{literal}':
            function()
            {
              $(this).dialog('close');
            }
        }
      }
    );
  }

  /**
   * check the validity of the condition
   * return Boolean : true if OK, otherwise false
   */
  var checkValidity = function ()
  {
    $(".error").removeClass('error');
    returned=true;

    if($('#iASEKeywordKeyword').val().length< {/literal}{$aseConfig.ase_keyword_minLength}{literal} )
    {
      $("#iASEKeywordKeyword").addClass('error');
      alert("{/literal}{'ase_error_keyword_length'|@translate}{literal}");
      returned=false;
    }

    if(!$('#iASEKeywordSearchName').attr('checked') &&
       !$('#iASEKeywordSearchDesc').attr('checked') &&
       !$('#iASEKeywordSearchFileName').attr('checked'))
    {
      $("#iASEKeywordSearchName, #iASEKeywordSearchDesc, #iASEKeywordSearchFileName").parent().addClass('error');
      alert("{/literal}{'ase_error_no_target'|@translate}{literal}");
      returned=false;
    }

    return(returned);
  }


  /**
   * the show() function display and manage a dialog box to choose categories
   * and the kind of test to apply
   *
   * @param options : properties to manage the dialog box
   *                  - id : a string to identify a DOM object ; this parameter
   *                         is given to the callback when the OK button is pushed
   *                  - values : an object with 3 properties
   *                               - keyword : the keyword to find
   *                               - optIgnoreCase : ignore case or not
   *                               - optWholeWords : search whol words only or not
   *                               - searchName : search inside picture name
   *                               - searchDesc : search inside picture desc
   *                               - searchFileName : search inside picture filename
   *                  - eventOK : a callback function, with 2 parameters : id of
   *                              the given DOM object and values parameted
   *                  - cBuilder : a criteriaBuilder object
   *                               if set, the dialog box manage automaticaly
   *                               the criteria builder interface
   */
  this.show = function (options)
  {
    showDialog(options);
  }

  /**
   * private function used to show the dialog box
   */
  var showDialog = function(options)
  {
    if(options.id!=null)
    {
      dialogOptions.id=options.id;
    }
    else
    {
      dialogOptions.id='';
    }

    if(options.eventOk!=null)
    {
      dialogOptions.eventOk=options.eventOk;
    }

    if(options.cBuilder!=null)
    {
      dialogOptions.cBuilder=options.cBuilder;
      dialogOptions.cBuilder.doAction('setOptions',
        {
          onEdit:function (e) { editCB(e.data); },
          onDelete:function (e) { deleteCB(e.data); },
        }
      );
    }

    if(options.values!=null)
    {
      dialogOptions.values=jQuery.extend(dialogOptions.values, options.values);
    }
    else
    {
      dialogOptions.values.keyword='';
      dialogOptions.values.optIgnoreCase='y';
      dialogOptions.values.optWholeWords='n';
      dialogOptions.values.searchName='y';
      dialogOptions.values.searchDesc='y';
      dialogOptions.values.searchFileName='n';
    }

    $('#iASEKeywordKeyword').val(dialogOptions.values.keyword);
    $('#iASEKeywordIgnoreCase').attr('checked', dialogOptions.values.optIgnoreCase=='y');
    $('#iASEKeywordWholeWords').attr('checked', dialogOptions.values.optWholeWords=='y');
    $('#iASEKeywordSearchName').attr('checked', dialogOptions.values.searchName=='y');
    $('#iASEKeywordSearchDesc').attr('checked', dialogOptions.values.searchDesc=='y');
    $('#iASEKeywordSearchFileName').attr('checked', dialogOptions.values.searchFileName=='y');


    $("#iDialogASEKeywordChoose").dialog('open');
  }



  /**
   * manage the 'edit' button from criteria builder interface
   * @param String itemId : the itemId
   */
  var editCB = function (itemId)
  {
    extraData=dialogOptions.cBuilder.doAction('getExtraData', itemId);
    showDialog(
      {
        id:itemId,
        values:
          {
            keyword:extraData.param.keyword,
            optIgnoreCase:extraData.param.optIgnoreCase,
            optWholeWords:extraData.param.optWholeWords,
            searchName:extraData.param.searchName,
            searchDesc:extraData.param.searchDesc,
            searchFileName:extraData.param.searchFileName
          },
      }
    );
  }

  /**
   * manage the 'delete' button from criteria builder interface
   * @param String itemId : the itemId
   */
  var deleteCB = function (itemId)
  {
    dialogOptions.cBuilder.doAction('delete', itemId);
  }

  /**
   * set the content for the cBuilder item
   */
  var setCBuilderItem = function(id)
  {
    var content="<div>{/literal}{'ase_search_the_keyword'|@translate}{literal}&nbsp;";

    content+="<span style='font-style:italic;text-decoration:underline;'>"+dialogOptions.values.keyword+"</span>&nbsp:";

    if(dialogOptions.values.searchName=='y') content+="<br>&nbsp;-&nbsp;{/literal}{'ase_search_into_name'|@translate}{literal}";
    if(dialogOptions.values.searchDesc=='y') content+="<br>&nbsp;-&nbsp;{/literal}{'ase_search_into_desc'|@translate}{literal}";
    if(dialogOptions.values.searchFileName=='y') content+="<br>&nbsp;-&nbsp;{/literal}{'ase_search_into_filename'|@translate}{literal}";

    if(dialogOptions.values.optIgnoreCase=='y') content+="<br>&nbsp;-&nbsp;{/literal}{'ase_search_with_case_ignored'|@translate}{literal}";
    if(dialogOptions.values.optWholeWords=='y') content+="<br>&nbsp;-&nbsp;{/literal}{'ase_search_with_whole_words'|@translate}{literal}";


    content+="</div>";

    if(id=='')
    {
      //no id:add a new item in the list
      dialogOptions.cBuilder.doAction(
        'add',
        content,
        criteriaBuilder.makeExtendedData(
          'ASEKeyword',
          {
            keyword:dialogOptions.values.keyword,
            optIgnoreCase:dialogOptions.values.optIgnoreCase,
            optWholeWords:dialogOptions.values.optWholeWords,
            searchName:dialogOptions.values.searchName,
            searchDesc:dialogOptions.values.searchDesc,
            searchFileName:dialogOptions.values.searchFileName
          }
        )
      );
    }
    else
    {
      // update item
      dialogOptions.cBuilder.doAction(
        'edit',
        id,
        content,
        criteriaBuilder.makeExtendedData(
          'ASEKeyword',
          {
            keyword:dialogOptions.values.keyword,
            optIgnoreCase:dialogOptions.values.optIgnoreCase,
            optWholeWords:dialogOptions.values.optWholeWords,
            searchName:dialogOptions.values.searchName,
            searchDesc:dialogOptions.values.searchDesc,
            searchFileName:dialogOptions.values.searchFileName
          }
        )
      );
    }
  }

  initDialogBox();
}


</script>
{/literal}

<div id="iDialogASEKeywordChoose" style='display:none;'>

  <table class="formtable">
    <tr>
      <td>{'ase_keyword'|@translate}</td>
      <td>
        <input type="text" id="iASEKeywordKeyword"><br>
        <label><input type="checkbox" id='iASEKeywordIgnoreCase'>&nbsp;{'ase_ignore_case'|@translate}<label><br>
        <label><input type="checkbox" id='iASEKeywordWholeWords'>&nbsp;{'ase_whole_words_only'|@translate}<label>
      </td>
    </tr>

    <tr>
      <td>{'ase_search_into'|@translate}</td>
      <td>
        <label><input type="checkbox" id='iASEKeywordSearchName'>&nbsp;{'ase_picture_name'|@translate}<label><br>
        <label><input type="checkbox" id='iASEKeywordSearchDesc'>&nbsp;{'ase_picture_desc'|@translate}<label><br>
        <label><input type="checkbox" id='iASEKeywordSearchFileName'>&nbsp;{'ase_picture_filename'|@translate}<label>
      </td>
    </tr>

  </table>

</div>


